# TODO: pass rpmldflags
Summary:	MongoDB client shell and tools
Summary(pl.UTF-8):	Powłoka kliencka i narzędzia dla bazy danych MongoDB
Name:		mongodb
Version:	2.0.6
Release:	2
License:	AGPL v3
Group:		Applications/Databases
Source0:	http://downloads.mongodb.org/src/%{name}-src-r%{version}.tar.gz
# Source0-md5:	b3b32fecdcbe8e8068ec2989be9d2da4
Source1:	%{name}.logrotate
Source2:	%{name}.init
Patch0:		config.patch
Patch1:		%{name}-system-libs.patch
Patch2:		%{name}-build.patch
Patch3:		boost-1.50.patch
URL:		http://www.mongodb.org/
BuildRequires:	boost-devel >= 1.42
BuildRequires:	libpcap-devel
BuildRequires:	libstdc++-devel >= 6:4.0
BuildRequires:	pcre-cxx-devel
BuildRequires:	pcre-devel
BuildRequires:	readline-devel
BuildRequires:	rpmbuild(macros) >= 1.228
BuildRequires:	scons >= 1.2
BuildRequires:	sed >= 4.0
BuildRequires:	snappy-devel
BuildRequires:	v8-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Mongo (from "huMONGOus") is a schema-free document-oriented database.
It features dynamic profileable queries, full indexing, replication
and fail-over support, efficient storage of large binary data objects,
and auto-sharding.

This package provides the mongo shell, import/export tools, and other
client utilities.

%description -l pl.UTF-8
Mongo (od "huMONGOus") to baza danych zorientowana na dokumenty
pozbawione schematu. Obsługuje dynamicznie profilowane zapytania,
pełne indeksowanie, replikację i fail-over, wydajne składowanie dużych
obiektów danych binarnych oraz automatyczne dzielenie.

Ten pakiet zawiera powłokę mongo, narzędzia do eksportu/importu danych
oraz inne narzędzia klienckie.

%package libs
Summary:	MongoDB client library
Summary(pl.UTF-8):	Biblioteka kliencka MongoDB
Group:		Libraries

%description libs
Mongo (from "huMONGOus") is a schema-free document-oriented database.

This package provides the mongo client library.

%description libs -l pl.UTF-8
Mongo (od "huMONGOus") to baza danych zorientowana na dokumenty
pozbawione schematu.

Ten pakiet zawiera bibliotekę kliencką mongo.

%package devel
Summary:	Header files for MongoDB client library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki klienckiej MongoDB
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Mongo (from "huMONGOus") is a schema-free document-oriented database.

This package provides the header files needed to develop MongoDB
client software.

%description devel -l pl.UTF-8
Mongo (od "huMONGOus") to baza danych zorientowana na dokumenty
pozbawione schematu.

Ten pakiet zawiera pliki nagłówkowe potrzebne do tworzenia
oprogramowania klienckiego dla MongoDB.

%package static
Summary:	Static MongoDB client library
Summary(pl.UTF-8):	Statyczna biblioteka kliencka MongoDB
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description static
Mongo (from "huMONGOus") is a schema-free document-oriented database.

This package provides the MongoDB static client library.

%description static -l pl.UTF-8
Mongo (od "huMONGOus") to baza danych zorientowana na dokumenty
pozbawione schematu.

Ten pakiet zawiera statyczną bibliotekę kliencką MongoDB.

%package server
Summary:	MongoDB server, sharding server, and support scripts
Summary(pl.UTF-8):	Serwer MongoDB, serwer dzielący oraz skrypty pomocnicze
Group:		Applications/Databases
Requires:	%{name} = %{version}-%{release}
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts
Provides:	group(mongod)
Provides:	user(mongod)
Conflicts:	logrotate < 3.8.0

%description server
Mongo (from "huMONGOus") is a schema-free document-oriented database.

This package provides the mongo server software, mongo sharding server
software, default configuration files, and init.d scripts.

%description server -l pl.UTF-8
Mongo (od "huMONGOus") to baza danych zorientowana na dokumenty
pozbawione schematu.

Ten pakiet zawiera serwer mongo, serwer dzielący, pliki domyślnej
konfiguracji oraz skrypty init.d.

%prep
%setup -q -n %{name}-src-r%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%{__sed} -i -e 's,-O3,%{rpmcxxflags} %{rpmcppflags},' SConstruct

# Fix permissions
find -type f -executable | xargs chmod a-x

# force system pcre/js/snappy
%{__rm} -r third_party/{js-1.7,pcre-7.4,snappy,*.py}

%build
%scons \
	--prefix=$RPM_BUILD_ROOT%{_prefix} \
	--sharedclient \
	--full all \
	--usev8 \
	--cxx=%{__cxx}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_mandir}/man1} \
	$RPM_BUILD_ROOT/etc/{logrotate.d,rc.d/init.d,sysconfig} \
	$RPM_BUILD_ROOT%{_var}/{lib,log}/mongo

# XXX: scons is so great, recompiles everything here!
%scons install \
	--prefix=$RPM_BUILD_ROOT%{_prefix} \
	--sharedclient \
	--full \
	--usev8 \
	--cxx=%{__cxx}

cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/mongod
install -p %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/mongod
cp -p rpm/mongod.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/mongod
cp -p rpm/mongod.conf $RPM_BUILD_ROOT%{_sysconfdir}/mongod.conf
cp -p debian/*.1 $RPM_BUILD_ROOT%{_mandir}/man1

touch $RPM_BUILD_ROOT%{_var}/log/mongo/mongod.log

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%pre server
%groupadd -g 258 -r mongod
%useradd -u 258 -r -g mongod -d %{_var}/lib/mongo -s /bin/false -c "MongoDB Database Server" mongod

%post server
/sbin/chkconfig --add mongod
%service mongod restart

%preun server
if [ "$1" = "0" ]; then
	%service -q mongod stop
	/sbin/chkconfig --del mongod
fi

%postun server
if [ "$1" = "0" ]; then
	%userremove mongod
	%groupremove mongod
fi

%files
%defattr(644,root,root,755)
%doc README GNU-AGPL-3.0.txt
%attr(755,root,root) %{_bindir}/bsondump
%attr(755,root,root) %{_bindir}/mongo
%attr(755,root,root) %{_bindir}/mongodump
%attr(755,root,root) %{_bindir}/mongoexport
%attr(755,root,root) %{_bindir}/mongofiles
%attr(755,root,root) %{_bindir}/mongoimport
%attr(755,root,root) %{_bindir}/mongorestore
%attr(755,root,root) %{_bindir}/mongosniff
%attr(755,root,root) %{_bindir}/mongostat
%attr(755,root,root) %{_bindir}/mongotop
%{_mandir}/man1/bsondump.1*
%{_mandir}/man1/mongo.1*
%{_mandir}/man1/mongodump.1*
%{_mandir}/man1/mongoexport.1*
%{_mandir}/man1/mongofiles.1*
%{_mandir}/man1/mongoimport.1*
%{_mandir}/man1/mongosniff.1*
%{_mandir}/man1/mongostat.1*
%{_mandir}/man1/mongorestore.1*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmongoclient.so

%files devel
%defattr(644,root,root,755)
%{_includedir}/mongo

%files static
%defattr(644,root,root,755)
%{_libdir}/libmongoclient.a

%files server
%defattr(644,root,root,755)
#%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/mongod.conf
%attr(754,root,root) /etc/rc.d/init.d/mongod
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/mongod
%config(noreplace) /etc/logrotate.d/mongod
%attr(755,root,root) %{_bindir}/mongod
%attr(755,root,root) %{_bindir}/mongos
%{_mandir}/man1/mongod.1*
%{_mandir}/man1/mongos.1*
%attr(755,mongod,mongod) %dir %{_var}/lib/mongo
%attr(755,mongod,mongod) %dir %{_var}/log/mongo
%attr(640,mongod,mongod) %config(noreplace) %verify(not md5 mtime size) %{_var}/log/mongo/mongod.log
%changelog
* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> bced33e
One more boost 1.50 problem fixed
Release 2

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> 886c109
More FS V3 fixes

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> 9cae008
FILESYSTEM V3 fix

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> d7c33f7
TIME_UTC has grown an underscore

* Wed Jul 11 2012 Jan Rękorajski <baggins@pld-linux.org> 2d54e68
BOOST_FILESYSTEM V2 is gone in boost 1.50

* Wed Jul 04 2012 Jacek Konieczny <jajcus@pld-linux.org> 2633a24
- do not package the /etc directory

* Wed Jun 13 2012 Jacek Konieczny <jajcus@pld-linux.org> 037ecc1
- Version: 2.0.6

* Mon Apr 23 2012 Elan Ruusamäe <glen@pld-linux.org> e5fd642
- add missing network check block

* Mon Apr 23 2012 Elan Ruusamäe <glen@pld-linux.org> c93cbd6
- formatting

* Mon Apr 23 2012 Elan Ruusamäe <glen@pld-linux.org> ab177c4
- restore LSB header (can be useful with systemd)

* Sun Apr 22 2012 aredridel <aredridel@pld-linux.org> 138b8a6
Make init script sane

* Wed Mar 28 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 21b5056
- release 4

* Sun Mar 11 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> c6dc23b
- release 3

* Sun Feb 05 2012 Jan Rękorajski <baggins@pld-linux.org> 51f3a0f
- rel 2
- logrotate 3.8.0 requires "su" option for non-root writable dirs

* Thu Dec 01 2011 Jan Rękorajski <baggins@pld-linux.org> 176b215
- fixed libraries ordering for linking

* Thu Dec 01 2011 Jan Rękorajski <baggins@pld-linux.org> dd23610
- attempt to fix linking of mongod

* Mon Nov 07 2011 Jakub Bogusz <qboosh@pld-linux.org> 04298a8
- updated to 2.0.1 (1.8.x left on MONGODB_1_8 branch)
- updated config patch
- added system-libs patch to use system snappy and pcre
- added build patch to fix shared lib build

* Tue Nov 01 2011 Jakub Bogusz <qboosh@pld-linux.org> c9011c6
- updated to 1.8.4 (latest 1.8.x)

* Tue Nov 01 2011 Jakub Bogusz <qboosh@pld-linux.org> f5624e0
- libs/devel/static split

* Tue Nov 01 2011 Jakub Bogusz <qboosh@pld-linux.org> 7165862
- pl, cleanup

